Package org.zkoss.stateless.sul

## Interface IInputgroup

- All Superinterfaces:
    `IAnyGroup<IInputgroup>`, `IChildable<IInputgroup,​IChildrenOfInputgroup>`, `IComponent<IInputgroup>`, `IHtmlBasedComponent<IInputgroup>`, `IXulElement<IInputgroup>`

      public interface IInputgroup
      extends IXulElement<IInputgroup>, IAnyGroup<IInputgroup>, IChildable<IInputgroup,​IChildrenOfInputgroup>

  Immutable `Inputgroup` component

  An inputgroup.

  Inspired by Bootstrap’s Input group and Button group. By prepending or appending some components to the input component, you can merge them like a new form-input component.

  ## Example

       @RichletMapping("/example")
       public IComponent example() {
           return IVlayout.of(
               IInputgroup.of(ILabel.of("@"), ITextbox.DEFAULT),
               IInputgroup.of(ITextbox.DEFAULT.withPlaceholder("Recipient's username"), ILabel.of("@example.com")),
               IInputgroup.of(ILabel.of("$"), ITextbox.DEFAULT, ILabel.of(".00")),
               IInputgroup.of(ILabel.of("With textarea"), ITextbox.ofCols(30).withRows(5).withMultiline(true))
           );
       }

  Author:
    katherine
  See Also:
    `Inputgroup`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IInputgroup.Builder` | Builds instances of type `IInputgroup`.
    `static class` | `IInputgroup.Orient` | Specifies the orient of `IInputgroup` component
    `static class` | `IInputgroup.Updater` | Builds an updater of type `IInputgroup` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IInputgroup` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getOrient()` | Returns the orient.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static IInputgroup` | `of​(java.lang.Iterable<? extends IChildrenOfInputgroup> children)` | Returns the instance with the given `IChildrenOfInputgroup` children.
    `static IInputgroup` | `of​(IChildrenOfInputgroup... children)` | Returns the instance with the given `IChildrenOfInputgroup` children.
    `static IInputgroup` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `IInputgroup` | `withOrient​(java.lang.String orient)` | Returns a copy of `this` immutable component with the specified `orient`.
    `default IInputgroup` | `withOrient​(IInputgroup.Orient orient)` | Returns a copy of `this` immutable component with the specified `orient`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IInputgroup DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.wgt.Inputgroup"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IInputgroup>`
      Returns:

    - #### getOrient

          default java.lang.String getOrient()

      Returns the orient.

      Default: `"horizontal"`.

    - #### withOrient

          IInputgroup withOrient​(java.lang.String orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - Either `"horizontal"` or `"vertical"`

        Default: `"horizontal"`.

      Returns:
        A modified copy of the `this` object

    - #### withOrient

          default IInputgroup withOrient​(IInputgroup.Orient orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - The `orient`

        Default: `"horizontal"`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static IInputgroup of​(java.lang.Iterable<? extends IChildrenOfInputgroup> children)

      Returns the instance with the given `IChildrenOfInputgroup` children.
      Parameters:
        `children` - The children of `IChildrenOfInputgroup`

    - #### of

          static IInputgroup of​(IChildrenOfInputgroup... children)

      Returns the instance with the given `IChildrenOfInputgroup` children.
      Parameters:
        `children` - The children of `IChildrenOfInputgroup`

    - #### ofId

          static IInputgroup ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component.